<template>
<section class="note">
  <button class="delete" @click.stop="$emit('delete')">×</button>
  <section class="body">
    <input class="name" placeholder="name" v-model="name" />
    <input class="message" placeholder="message" type="textarea" v-model="message" />
    <div v-show="isModified" class="edit-actions">
      <button @click.stop="save">save</button>
      <button @click.stop="revert">revert</button>
    </div>
  </section>
</section>
</template>

<script>
import sync from './store/helpers/sync';
import syncList from './store/proxies/list/sync';

const { syncState } = sync({ getState: 'item', setState: 'update' })
const { syncActions, syncGetters } = syncList({ namespace: [ 'notes' ], getId: (self) => self.id })

export default {
  name: 'Note',
  description: [
    '`Note` displays the note'
  ].join(' '),
  props: {
    id: {
      type: String
    }
  },
  computed: {
    ...syncState([
      'name',
      'message'
    ]),
    ...syncGetters([
      'item',
      'isModified'
    ])
  },
  methods: {
    ...syncActions([
      'update',
      'revert',
      'save'
    ])
  }
};
</script>

<style lang="scss">
  .note {
    border: 2px solid #D8D8D8;
    position: relative;
    padding: 1rem;
    margin-bottom: 1rem;

    button.delete {
      $size: 2rem;
      position: absolute;
      top: -$size/2;
      right: -$size/2;
      width: $size;
      height: $size;
      display: block;
      display: flex;
      justify-content: center;
      align-items: center;
      padding: 0;
      border: 2px solid #DD0000;
      border-radius: 50%;

      background: #CC0000;
      color: white;

      &:hover {
        background: #EE0000;
      }
    }

    .body {
      display: flex;
      flex-direction: column;

      & > *:not(:first-child) {
        margin-top: 1rem;
      }

      .edit-actions {
        display: flex;
        justify-content: space-between;
      }
    }

  }
</style>
